package com.jd.jdsdk;

import android.util.Log;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/**
 * JdsdkPlugin
 */
public class JdsdkPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware {
    public static JDHelper mJDHelper;
    private MethodChannel channel;
    private ActivityPluginBinding binding;
    @Override
    public void onAttachedToEngine(FlutterPluginBinding flutterPluginBinding) {
//    mJDHelper = JDHelper.getInstance(flutterPluginBinding.getApplicationContext());
        channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "jdsdk");
        channel.setMethodCallHandler(this);
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        try {
            if (mJDHelper == null) {
                mJDHelper = JDHelper.getInstance(binding);
            }
            if (call.method.equals("getPlatformVersion")) {
                result.success("Android " + android.os.Build.VERSION.RELEASE);
            } else if (call.method.equals("init")) {
                mJDHelper.initKepler(call, result);
            } else if (call.method.equals("openUrl")) {
                Log.d("flutter-test", "openUrl");
                mJDHelper.openUrl(call, result);
            } else {
                result.notImplemented();
            }
        } catch (Exception e) {
            Log.d("zhiying", "捕获出错");
            e.printStackTrace();
        }
    }

    @Override
    public void onDetachedFromEngine(FlutterPluginBinding binding) {
        channel.setMethodCallHandler(null);
        mJDHelper = null;
    }

    @Override
    public void onAttachedToActivity(ActivityPluginBinding binding) {
        Log.d("flutter-taoke", "onAttachedToActivity" + binding);
        this.binding=binding;
        mJDHelper = JDHelper.getInstance(binding);
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {

    }

    @Override
    public void onReattachedToActivityForConfigChanges(ActivityPluginBinding binding) {

    }

    @Override
    public void onDetachedFromActivity() {

    }
}
